<template>
  <v-container
    fluid
    pa-0
    ma-0
  >
    <v-card>
      <div class="text-center">
        <h1>The Core JLU Data</h1>
      </div>
      <v-row>
        <v-col

          class="ma-2"
        >
          <v-data-table
            :headers="headers"
            :items="jluData"
            :sort-by.sync="sortBy"
            :sort-desc.sync="sortDesc"
          >
            <!-- eslint-disable-next-line -->
  <template v-slot:item.editJLU="{ item }">
              <v-icon
                small
                class="mr-2"
                @click="editJLU(item)"
              >
                mdi-pencil
              </v-icon>
            </template>
          </v-data-table>
        </v-col>
      </v-row>
    </v-card>
    <v-dialog
      v-model="editedJLUDialog"
      :max-width="`${vW}px`"
      persistent
    >
      <v-card>
        <v-card-title>
          <div class="text-center">
            Edit JLU
          </div>
        </v-card-title>

        <v-card-text>
          <v-container>
            <!-- <v-row>
              editedJLU: {{ editedJLU }}
            </v-row> -->
            <v-row>
              <v-col
                cols="4"
              >
                <v-text-field
                  v-model="editedJLU.romanCode"
                  :disabled="editedJLU.id===''"
                  label="Roman Code"
                />
              </v-col>
              <v-col
                cols="4"
              >
                <v-text-field
                  v-if="editedJLU.id!==''"
                  v-model="editedJLU.jlu"
                  :readonly="editedJLU.id!==''"
                  label="JLU"
                />
              </v-col>
              <v-col
                cols="4"
              >
                <v-text-field
                  v-model="editedJLU.wbs"
                  :disabled="editedJLU.id===''"
                  label="WBS"
                />
              </v-col>
            </v-row>
            <v-row
              v-if="editedJLU.lastModifiedBy!==''"
            >
              <v-col
                class="py-2"
                cols="12"
              >
                Last Modified By {{ editedJLU.lastModifiedBy }}  on {{ editedJLU.lastModified }}
              </v-col>
            </v-row>

            <v-spacer />
          </v-container>
        </v-card-text>
        <!-- editedJLU: {{editedJLU}} -->
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="blue darken-1"
            text
            @click="closeEditJLU"
          >
            Cancel
          </v-btn>
          <v-btn
            v-if="editedJLU.id!==''"
            color="blue darken-1"
            :disabled="editedJLU.jluId===''"
            text
            @click="saveEditJLU"
          >
            Save
          </v-btn>
          <v-btn
            v-if="editedJLU.id===''"
            color="blue darken-1"
            :disabled="editedJLU.jluId===''"
            text
            @click="saveEditJLU"
          >
            Add
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
// eslint-disable-next-line
import { cloneDeep, isEqual } from 'lodash';
// eslint-disable-next-line
import { patch, post, get } from 'kyd-utils';

export default {
  name: 'Home',
  components: {
  },
  data: () => ({
    sortBy: 'romanCode',
    sortDesc: false,
    headers: [
      {
        text: 'JLU',
        align: 'start',
        width: '30%',
        value: 'jlu',
      },
      {
        text: 'Roman Code',
        align: 'start',
        width: '30%',
        value: 'romanCode',
      },
      {
        text: 'WBS',
        align: 'start',
        width: '30%',
        value: 'wbs',
      },
      {
        text: 'Edit JLU',
        align: 'center',
        width: '10%',
        sortable: false,
        value: 'editJLU',
      },
    ],
    jluData: [],
    editedJLU: {
      jluId: '',
      jlu: '',
      romanCode: '',
      wbs: '',
      lastModified: null,
      lastModifiedBy: '',
    },
    defJLU: {
      jluId: '',
      jlu: '',
      romanCode: '',
      wbs: '',
      lastModified: null,
      lastModifiedBy: '',
    },
    editedJLUDialog: false,
    editedIndex: -1,
  }),
  computed: {
    vW: {
      get() {
        return this.$store.state.app.vWH.x * 0.85;
      },
    },
  },
  watch: {
  },
  mounted() {
    this.refreshTable();
  },
  methods: {
    async refreshTable() {
      const response = await get('/jlu-data');
      // console.log('the resp', response);
      this.jluData = response.data;
    },
    editJLU(i) {
      // console.log('the jlu', i);
      this.editedIndex = this.jluData.indexOf(i);
      this.editedJLU = {
        ...this.editedJLU,
        ...i,
      };
      this.editedJLUDialog = true;
    },
    closeEditJLU() {
      this.editedJLUDialog = false;
      this.editedIndex = -1;
      const defJ = cloneDeep(this.defJLU);
      this.editedJLU = defJ;
    },
    async saveEditJLU() {
      const payload = this.editedJLU;
      const x = Object.entries(payload)
        .reduce((acc, [key, value]) => (value !== '' && value !== undefined ? { ...acc, [key]: value } : acc), {});
      const idV = payload.jluId;
      const filter = {
        filter: [{ key: 'jluId', equals: idV }],
      };
      const params = { params: filter };
      // const x1 = Object.entries(x)
      //   .reduce((acc, [key, value]) => (key !== 'jluOrigBid'
      //     && key !== 'approvedBudget'
      //     && key !== 'romanCode'
      //     && key !== 'jlu'
      //     ? { ...acc, [key]: value } : acc), {});
      const isEdit = (payload.id !== '');

      // console.log('item to save', payload2);
      if (isEdit === true) {
        // console.log('about to save', x, params);
        await patch(
          '/jlu-data-patch',
          x,
          params,
        );
        // console.log('post patch', p);
      } else {
        // const params = { params: this.phasingsMeta };
        await post(
          '/jlu-data-post',
          [x],
        );
        // console.log('the save objects', test);
      }
      this.refreshTable();
      this.closeEditJLU();
    },
  },
};

</script>
